Index: /diffs/smtube_1.7_GA.diff
===================================================================
--- /diffs/smtube_1.7_GA.diff	(revision 150)
+++ /diffs/smtube_1.7_GA.diff	(revision 151)
@@ -1,5 +1,5 @@
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/build_os2.cmd E:\trees\smtube\trunk/build_os2.cmd
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/build_os2.cmd E:\trees\smtube\trunk/build_os2.cmd
 --- E:\trees\smtube\trunk\..\vendor\current/build_os2.cmd	1970-01-01 01:00:00.000000000 +0100
-+++ E:\trees\smtube\trunk/build_os2.cmd	2013-11-28 12:41:08.000000000 +0100
++++ E:\trees\smtube\trunk/build_os2.cmd	2013-11-28 12:54:50.000000000 +0100
 @@ -0,0 +1,288 @@
 +/* SMTube Build Script */
@@ -163,5 +163,5 @@
 +    when command = "DIFF" then do
 +
-+	address cmd 'diff -Naur ' || vendorDir || ' ' || sourceDir || ' -x *.qm -x geoip.dat -x conf.pri > ' || diffDir || 'smtube_' || SMTube_version || '_' || SMTube_build || '.diff'
++	address cmd 'diff -Naur ' || vendorDir || ' ' || sourceDir || ' > ' || diffDir || 'smtube_' || SMTube_version || '_' || SMTube_build || '.diff'
 +	
 +    end
@@ -291,5 +291,5 @@
 +    say "    diff (creates a diff from vendor to trunk)"
 +exit 255
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/get_svn_revision.sh E:\trees\smtube\trunk/get_svn_revision.sh
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/get_svn_revision.sh E:\trees\smtube\trunk/get_svn_revision.sh
 --- E:\trees\smtube\trunk\..\vendor\current/get_svn_revision.sh	2012-02-24 23:23:26.000000000 +0100
 +++ E:\trees\smtube\trunk/get_svn_revision.sh	2013-05-23 18:29:44.000000000 +0200
@@ -309,5 +309,5 @@
  OLD_REVISION=`cat src/svn_revision.h 2> /dev/null`
  
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/os2/smtube_de.txt E:\trees\smtube\trunk/os2/smtube_de.txt
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/os2/smtube_de.txt E:\trees\smtube\trunk/os2/smtube_de.txt
 --- E:\trees\smtube\trunk\..\vendor\current/os2/smtube_de.txt	1970-01-01 01:00:00.000000000 +0100
 +++ E:\trees\smtube\trunk/os2/smtube_de.txt	2013-05-27 16:30:32.000000000 +0200
@@ -408,5 +408,5 @@
 +  * erste Version
 +
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/os2/smtube_en.txt E:\trees\smtube\trunk/os2/smtube_en.txt
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/os2/smtube_en.txt E:\trees\smtube\trunk/os2/smtube_en.txt
 --- E:\trees\smtube\trunk\..\vendor\current/os2/smtube_en.txt	1970-01-01 01:00:00.000000000 +0100
 +++ E:\trees\smtube\trunk/os2/smtube_en.txt	2013-05-27 16:30:54.000000000 +0200
@@ -506,5 +506,5 @@
 +2013-05-23
 +  * first version
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/os2/smtube_fr.txt E:\trees\smtube\trunk/os2/smtube_fr.txt
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/os2/smtube_fr.txt E:\trees\smtube\trunk/os2/smtube_fr.txt
 --- E:\trees\smtube\trunk\..\vendor\current/os2/smtube_fr.txt	1970-01-01 01:00:00.000000000 +0100
 +++ E:\trees\smtube\trunk/os2/smtube_fr.txt	2013-05-28 12:53:00.000000000 +0200
@@ -613,5 +613,5 @@
 +2013-05-23
 +  * Version initiale
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/os2/smtube.ico E:\trees\smtube\trunk/os2/smtube.ico
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/os2/smtube.ico E:\trees\smtube\trunk/os2/smtube.ico
 --- E:\trees\smtube\trunk\..\vendor\current/os2/smtube.ico	1970-01-01 01:00:00.000000000 +0100
 +++ E:\trees\smtube\trunk/os2/smtube.ico	2013-05-23 19:53:18.000000000 +0200
@@ -1133,5 +1133,5 @@
 
 \ No newline at end of file
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/smtube.pro E:\trees\smtube\trunk/smtube.pro
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/smtube.pro E:\trees\smtube\trunk/smtube.pro
 --- E:\trees\smtube\trunk\..\vendor\current/smtube.pro	1970-01-01 01:00:00.000000000 +0100
 +++ E:\trees\smtube\trunk/smtube.pro	2013-05-23 18:30:40.000000000 +0200
@@ -1143,5 +1143,5 @@
 +src.file=src/smtube.pro
 \ No newline at end of file
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/src/main.cpp E:\trees\smtube\trunk/src/main.cpp
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/src/main.cpp E:\trees\smtube\trunk/src/main.cpp
 --- E:\trees\smtube\trunk\..\vendor\current/src/main.cpp	2013-01-12 01:03:30.000000000 +0100
 +++ E:\trees\smtube\trunk/src/main.cpp	2013-05-23 19:40:56.000000000 +0200
@@ -1155,5 +1155,5 @@
  #ifdef TRANSLATION_PATH
  	 QString s = QString(TRANSLATION_PATH);
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/src/players.cpp E:\trees\smtube\trunk/src/players.cpp
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/src/players.cpp E:\trees\smtube\trunk/src/players.cpp
 --- E:\trees\smtube\trunk\..\vendor\current/src/players.cpp	2013-01-12 01:03:30.000000000 +0100
 +++ E:\trees\smtube\trunk/src/players.cpp	2013-05-23 18:40:32.000000000 +0200
@@ -1172,10 +1172,27 @@
  	if (!fi.exists() || !fi.isExecutable() || fi.isDir()) {
  		qDebug("Player::exec: command: '%s' is not a valid executable", bin.toUtf8().constData());
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/src/smtube_os2.rc E:\trees\smtube\trunk/src/smtube_os2.rc
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/src/qtsingleapplication/qtlocalpeer.cpp E:\trees\smtube\trunk/src/qtsingleapplication/qtlocalpeer.cpp
+--- E:\trees\smtube\trunk\..\vendor\current/src/qtsingleapplication/qtlocalpeer.cpp	2013-11-28 13:04:16.000000000 +0100
++++ E:\trees\smtube\trunk/src/qtsingleapplication/qtlocalpeer.cpp	2013-11-28 13:03:38.000000000 +0100
+@@ -48,12 +48,11 @@
+ typedef BOOL(WINAPI*PProcessIdToSessionId)(DWORD,DWORD*);
+ static PProcessIdToSessionId pProcessIdToSessionId = 0;
+ #endif
+-#if defined(Q_OS_UNIX)
++#if defined(Q_OS_UNIX) || defined(Q_OS_OS2)
+ #include <time.h>
+ #include <unistd.h>
+ #endif
+ 
+-
+ namespace QtLP_Private {
+ #include "qtlockedfile.cpp"
+ #if defined(Q_OS_WIN)
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/src/smtube_os2.rc E:\trees\smtube\trunk/src/smtube_os2.rc
 --- E:\trees\smtube\trunk\..\vendor\current/src/smtube_os2.rc	1970-01-01 01:00:00.000000000 +0100
 +++ E:\trees\smtube\trunk/src/smtube_os2.rc	2013-05-23 19:46:54.000000000 +0200
 @@ -0,0 +1 @@
 +ICON	1    DISCARDABLE     "..\os2\smtube.ico"
-diff -Naur -x '*.qm' -x geoip.dat -x conf.pri E:\trees\smtube\trunk\..\vendor\current/src/smtube.pro E:\trees\smtube\trunk/src/smtube.pro
+diff -Naur E:\trees\smtube\trunk\..\vendor\current/src/smtube.pro E:\trees\smtube\trunk/src/smtube.pro
 --- E:\trees\smtube\trunk\..\vendor\current/src/smtube.pro	2013-05-03 23:03:38.000000000 +0200
 +++ E:\trees\smtube\trunk/src/smtube.pro	2013-11-28 11:55:12.000000000 +0100