Index: trunk/src/os2ahci/Makefile
===================================================================
--- trunk/src/os2ahci/Makefile	(revision 157)
+++ trunk/src/os2ahci/Makefile	(revision 158)
@@ -1,6 +1,8 @@
 ###############################################################################
-# Makefile - makefile for os2ahci driver using WATCOM compiler
+# Makefile - makefile for os2ahci driver
+# This is an Open Watcom makefile
 #
 # Copyright (c) 2010 Christian Mueller, Markus Thielen.
+# Copyright (c) 2013 David Azarewicz
 # Parts copied from/inspired by the Linux AHCI driver;
 # those parts are (c) Linux AHCI/ATA maintainers
@@ -19,6 +21,4 @@
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
 ###############################################################################
 # Environment
Index: trunk/src/os2ahci/README
===================================================================
--- trunk/src/os2ahci/README	(revision 157)
+++ trunk/src/os2ahci/README	(revision 158)
@@ -70,23 +70,6 @@
  - MAPSYM (part of the DDK)
 
-Simply use "wmake" or "wmake -a" to build the driver.
-
-The driver can also be built using the DDK tools, but this build
-is depreciated and is not kept up-to-date.
-
-The toolchain required for compilation consists of:
-
- - IBM OS/2 DDK version 9.23 or later (see ddk\base\h\version.mak)
- - Microsoft C600
- - ALP Assembler (part of DDK)
- - link.exe (part of DDK)
- - MAPSYM (part of the DDK)
-
-Use "nmake -f Makefile.old" or "nmake -f Makefile.old -a" to build
-the driver.
-
-When switching between building with the DDK and Open Watcom, it is
-recommended to do a clean first (wmake clean or nmake -f Makefile.old clean).
-
+Define DDK and WATCOM in the environment.
+Use "wmake" or "wmake -a" to build the driver. See _build.cmd.
 
 Installation
Index: trunk/src/os2ahci/_build.cmd
===================================================================
--- trunk/src/os2ahci/_build.cmd	(revision 158)
+++ trunk/src/os2ahci/_build.cmd	(revision 158)
@@ -0,0 +1,7 @@
+@echo off
+rem set VENDOR=Mensys BV
+rem set BLD_MAJOR=1
+rem set BLD_MINOR=27
+rem set WATCOM=i:\Watcom
+rem set DDK=i:\ddk
+wmake -a
Index: trunk/src/os2ahci/_clean.cmd
===================================================================
--- trunk/src/os2ahci/_clean.cmd	(revision 158)
+++ trunk/src/os2ahci/_clean.cmd	(revision 158)
@@ -0,0 +1,2 @@
+@echo off
+wmake clean
Index: trunk/src/os2ahci/_ibuild.cmd
===================================================================
--- trunk/src/os2ahci/_ibuild.cmd	(revision 157)
+++ 	(revision )
@@ -1,3 +1,0 @@
-@echo off
-nmake -f Makefile.old
-
Index: trunk/src/os2ahci/_iclean.cmd
===================================================================
--- trunk/src/os2ahci/_iclean.cmd	(revision 157)
+++ 	(revision )
@@ -1,2 +1,0 @@
-@echo off
-nmake -f Makefile.old clean
Index: trunk/src/os2ahci/_install.cmd
===================================================================
--- trunk/src/os2ahci/_install.cmd	(revision 158)
+++ trunk/src/os2ahci/_install.cmd	(revision 158)
@@ -0,0 +1,2 @@
+copy os2ahci.add c:\os2\boot\*
+copy os2ahci.sym c:\os2\boot\*
Index: trunk/src/os2ahci/_wbuild.cmd
===================================================================
--- trunk/src/os2ahci/_wbuild.cmd	(revision 157)
+++ 	(revision )
@@ -1,7 +1,0 @@
-@echo off
-rem set VENDOR=Mensys BV
-rem set BLD_MAJOR=1
-rem set BLD_MINOR=26
-rem set WATCOM=i:\Watcom
-rem set DDK=i:\ddk
-wmake
Index: trunk/src/os2ahci/_wclean.cmd
===================================================================
--- trunk/src/os2ahci/_wclean.cmd	(revision 157)
+++ 	(revision )
@@ -1,2 +1,0 @@
-@echo off
-wmake clean
Index: trunk/src/os2ahci/install.cmd
===================================================================
--- trunk/src/os2ahci/install.cmd	(revision 157)
+++ 	(revision )
@@ -1,2 +1,0 @@
-copy os2ahci.add c:\os2\boot\*
-copy os2ahci.sym c:\os2\boot\*